
/// Ticket data for one ticket
class TicketData {
  String activatedBy = "";
  String activationDate = "";
  String endDate = "";
  String purchaseDate = "";
  String purchasedBy = "";
  String giftCode = "";
  String type = "";
  String ticketID = "";

  TicketData({
    required this.activatedBy,
    required this.activationDate,
    required this.endDate,
    required this.purchaseDate,
    required this.purchasedBy,
    required this.giftCode,
    required this.type,
  });

  TicketData.fromJson(Map<dynamic, dynamic> json) {
    activatedBy = json['activatedBy'];
    activationDate = json['activationDate'];
    endDate = json['endDate'];
    purchaseDate = json['purchaseDate'];
    purchasedBy = json['purchasedBy'];
    giftCode = json['giftCode'];
    type = json['type'];
  }

  Map<String, Object?> toJson() {
    final Map<String, Object?> data = new Map<String, Object?>();
    data['activatedBy'] = this.activatedBy;
    data['activationDate'] = this.activationDate;
    data['endDate'] = this.endDate;
    data['purchaseDate'] = this.purchaseDate;
    data['purchasedBy'] = this.purchasedBy;
    data['giftCode'] = this.giftCode;
    data['type'] = this.type;
    return data;
  }

}

/// Data for a task for the game "Viten Kode"
class TaskData {
  String task = "";
  String one = "";
  String two = "";
  String three = "";
  String four = "";
  String five = "";
  String userID = "";

  TaskData({
    required this.task,
    required this.one,
    required this.two,
    required this.three,
    required this.four,
    required this.five,
  });

  TaskData.fromJson(Map<dynamic, dynamic> json) {
    task = json['oppgave'];
    one = json['1'];
    two = json['2'];
    three = json['3'];
    four = json['4'];
    five = json['5'];
  }

  Map<String, Object?> toJson() {
    final Map<String, Object?> data = new Map<String, Object?>();
    data['oppgave'] = this.task;
    data['1'] = this.one;
    data['2'] = this.two;
    data['3'] = this.three;
    data['4'] = this.four;
    data['5'] = this.five;
    return data;
  }
}

/// All tickets for one user
List<TicketData> userTickets = [];

/// All tickets for all users
List<TicketData> allUserTickets = [];

/// All tasks
List<TaskData> allTaskData = [];

/// User data
class UserData {
  String birthday = "";
  String email = "";
  String image = "";
  bool isAdmin = false;
  bool isEmployee = false;
  String name = "";
  String phone = "";
  String tickets = "";
  String userID = "";

  UserData({
    required this.birthday,
    required this.email,
    required this.image,
    required this.isAdmin,
    required this.isEmployee,
    required this.name,
    required this.phone,
    required this.tickets
  });

  UserData.fromJson(Map<dynamic, dynamic> json) {
    birthday = json['birthday'];
    email  = json['email'];
    image = json['image'];
    isAdmin = json['isAdmin'];
    isEmployee = json['isEmployee'];
    name = json['name'];
    phone = json['phone'];
    tickets = json['tickets'];
  }

  Map<String, Object?> toJson() {
    final Map<String, Object?> data = new Map<String, Object?>();
    data['birthday'] = this.birthday;
    data['email'] = this.email;
    data['image'] = this.image;
    data['isAdmin'] = this.isAdmin;
    data['isEmployee'] = this.isEmployee;
    data['name'] = this.name;
    data['phone'] = this.phone;
    data['tickets'] = this.tickets;
    return data;
  }

}


/// All users
List<UserData> allUserData = [];
UserData currentUser = UserData(birthday: "", email: "", image: "", isAdmin: false, isEmployee: false, name: "", phone: "", tickets: "");

/// All data about a blog
class BlogData {
  String blogID = "";
  String content = "";
  String image = "";
  bool notify = false;
  String publicationDate = "";
  String title = "";
  String author = "";
  String postContent = "";

  BlogData ({
    required this.content,
    required this.image,
    required this.notify,
    required this.publicationDate,
    required this.title,
    required this.author,
  });

  BlogData.fromJson(Map<dynamic, dynamic> json) {
    content = json['content'];
    image = json ['image'];
    notify = json['notify'];
    publicationDate = json['publicationDate'];
    title = json['title'];
    author = json['author'];
  }

  Map<dynamic, dynamic> toJson() {
    final Map<dynamic, dynamic> data = new Map<dynamic, dynamic>();
    data['content'] = this.content;
    data['image'] = this.image;
    data['notify'] = this.notify;
    data['publicationDate'] = this.publicationDate;
    data['title'] = this.title;
    data['author'] = this.author;
    return data;
  }
}

/// List of all blog objects
List<BlogData> allBlogs = [];